﻿#pragma once

#include "Common\StepTimer.h"
#include "DeviceResources.h"
#include "Content\ClipToTextRenderer.h"

// Renders Direct2D and 3D content on the screen.
namespace ClipToText
{
	class ClipToTextMain : public IDeviceNotify
	{
	public:
		ClipToTextMain(const std::shared_ptr<DeviceResources>& deviceResources);
		~ClipToTextMain();
		void CreateWindowSizeDependentResources();
		void Update();
		bool Render();

		// IDeviceNotify
		virtual void OnDeviceLost();
		virtual void OnDeviceRecreated();

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;

		std::unique_ptr<ClipToTextRenderer> m_clipToTextRenderer;

		// Rendering loop timer.
		DX::StepTimer m_timer;
	};
}