#pragma once
#include "PathGeometryDataEtc.h"

class InterpolatableGeometrySink : public ID2D1SimplifiedGeometrySink
{
private:
    LONG m_refCount;
    bool m_interpolate;
    float m_flatteningTolerance;
    PathGeometryData m_pathGeometryData;
    PathFigureData m_pathFigureData;
    D2D1_POINT_2F m_prevPoint;
    void Interpolate(D2D1_POINT_2F point0, D2D1_POINT_2F point1, std::vector<D2D1_POINT_2F>& points);

public:
    InterpolatableGeometrySink(bool interpolate = false,
                               float flatteningTolerance = D2D1_DEFAULT_FLATTENING_TOLERANCE);

    // IUnknown methods
    virtual ULONG STDMETHODCALLTYPE AddRef() override;
    virtual ULONG STDMETHODCALLTYPE Release() override;
    virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void **ppvObject) override;

    // ID2D1SimplifiedGeometrySink methods
    virtual void STDMETHODCALLTYPE SetFillMode(D2D1_FILL_MODE fillMode) override;
    virtual void STDMETHODCALLTYPE SetSegmentFlags(D2D1_PATH_SEGMENT vertexFlags) override;
    virtual void STDMETHODCALLTYPE BeginFigure(D2D1_POINT_2F startPoint, D2D1_FIGURE_BEGIN figureBegin) override;
    virtual void STDMETHODCALLTYPE AddLines(const D2D1_POINT_2F *points, UINT pointsCount) override;
    virtual void STDMETHODCALLTYPE AddBeziers(const D2D1_BEZIER_SEGMENT *beziers, UINT beziersCount) override;
    virtual void STDMETHODCALLTYPE EndFigure(D2D1_FIGURE_END figureEnd) override;
    virtual HRESULT STDMETHODCALLTYPE Close() override;

    // Method for this implementation
    PathGeometryData GetPathGeometryData();
};
