﻿#pragma once

#include <string>
#include "..\DeviceResources.h"
#include "..\Common\StepTimer.h"
#include "InterpolatableGeometrySink.h"

namespace OscillatingText
{
	// Renders the current FPS value in the bottom right corner of the screen using Direct2D and DirectWrite.
	class OscillatingTextRenderer
	{
	public:
		OscillatingTextRenderer(const std::shared_ptr<DeviceResources>& deviceResources);
		void CreateDeviceDependentResources();
		void ReleaseDeviceDependentResources();
        void CreateWindowSizeDependentResources();
		void Update(DX::StepTimer const& timer);
		void Render();

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;

        PathGeometryData                          m_srcPathGeometryData;
        PathGeometryData                          m_dstPathGeometryData;
        Microsoft::WRL::ComPtr<ID2D1PathGeometry> m_textGeometry;
        D2D1_RECT_F                               m_geometryBounds;
        D2D1::Matrix3x2F                          m_displayTransform;

		Microsoft::WRL::ComPtr<ID2D1SolidColorBrush>    m_whiteBrush;
		Microsoft::WRL::ComPtr<ID2D1DrawingStateBlock>  m_stateBlock;
	};
}