﻿#pragma once

#include "Common\StepTimer.h"
#include "DeviceResources.h"
#include "Content\OscillatingTextRenderer.h"

namespace OscillatingText
{
	class OscillatingTextMain : public IDeviceNotify
	{
	public:
		OscillatingTextMain(const std::shared_ptr<DeviceResources>& deviceResources);
		~OscillatingTextMain();
		void CreateWindowSizeDependentResources();
		void Update();
		bool Render();

		// IDeviceNotify
		virtual void OnDeviceLost();
		virtual void OnDeviceRecreated();

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;

		// Renderer
		std::unique_ptr<OscillatingTextRenderer> m_oscillatingTextRenderer;

		// Rendering loop timer.
		DX::StepTimer m_timer;
	};
}