#pragma once

struct PathSegmentData
{
    bool IsBezier;
    std::vector<D2D1_POINT_2F> Points;          // for IsBezier == false
    std::vector<D2D1_BEZIER_SEGMENT> Beziers;   // for IsBezier == true
};

struct PathFigureData
{
    D2D1_POINT_2F StartPoint;
    D2D1_FIGURE_BEGIN FigureBegin;
    D2D1_FIGURE_END FigureEnd;
    std::vector<PathSegmentData> Segments;
};

struct PathGeometryData
{
    D2D1_FILL_MODE FillMode;
    std::vector<PathFigureData> Figures;

    Microsoft::WRL::ComPtr<ID2D1PathGeometry> GeneratePathGeometry(ID2D1Factory * factory);
};