﻿#pragma once

#include "Common\StepTimer.h"
#include "DeviceResources.h"
#include "Content\RealTextEditorRenderer.h"

namespace RealTextEditor
{
	class RealTextEditorMain : public IDeviceNotify
	{
	public:
		RealTextEditorMain(const std::shared_ptr<DeviceResources>& deviceResources);
		~RealTextEditorMain();
		void CreateWindowSizeDependentResources();
		void Update();
		bool Render();

		// IDeviceNotify
		virtual void OnDeviceLost();
		virtual void OnDeviceRecreated();

        // Asynchronous pointer events
        void OnPointerPressed(unsigned int id, Windows::Foundation::Point point);
        void OnPointerMoved(unsigned int id, Windows::Foundation::Point point);
        void OnPointerReleased(unsigned int id, Windows::Foundation::Point point);

	private:
		// Cached pointer to device resources.
		std::shared_ptr<DeviceResources> m_deviceResources;

		std::unique_ptr<RealTextEditorRenderer> m_realTextEditorRenderer;

		// Rendering loop timer.
		DX::StepTimer m_timer;
	};
}