#pragma once

namespace SimpleDWriteLib
{
    [Windows::Foundation::Metadata::WebHostHidden]
    public ref class TextGeometryGenerator sealed : public Windows::UI::Xaml::DependencyObject
    {
    private:
        Microsoft::WRL::ComPtr<ID2D1Factory>          m_d2dFactory;
        Microsoft::WRL::ComPtr<IDWriteFactory>        m_dwriteFactory;
        Microsoft::WRL::ComPtr<IDWriteFontCollection> m_fontCollection;

        // Dependency properties
        static Windows::UI::Xaml::DependencyProperty^ fontFamiliesProperty;
        static Windows::UI::Xaml::DependencyProperty^ textProperty;
        static Windows::UI::Xaml::DependencyProperty^ fontFamilyProperty;
        static Windows::UI::Xaml::DependencyProperty^ fontSizeProperty;
        static Windows::UI::Xaml::DependencyProperty^ fontStyleProperty;
        static Windows::UI::Xaml::DependencyProperty^ fontWeightProperty;

        static Windows::UI::Xaml::DependencyProperty^ interpolateProperty;
        static Windows::UI::Xaml::DependencyProperty^ geometryProperty;
        static Windows::UI::Xaml::DependencyProperty^ flattenedGeometryProperty;

        static void OnPropertyChangedStatic(Windows::UI::Xaml::DependencyObject^ obj, Windows::UI::Xaml::DependencyPropertyChangedEventArgs^ args);
        void OnPropertyChanged(Windows::UI::Xaml::DependencyPropertyChangedEventArgs^ args);

    public:
        TextGeometryGenerator();

        // FontFamilies property
        static property Windows::UI::Xaml::DependencyProperty^ FontFamiliesProperty
        {
            Windows::UI::Xaml::DependencyProperty^ get()
            {
                return fontFamiliesProperty;
            }
        }

        property Windows::Foundation::Collections::IVector<Platform::String^>^ FontFamilies
        {
            Windows::Foundation::Collections::IVector<Platform::String^>^ get()
            {
                return safe_cast<Windows::Foundation::Collections::IVector<Platform::String^>^>(GetValue(FontFamiliesProperty));
            }
        }

        // Text property
        static property Windows::UI::Xaml::DependencyProperty^ TextProperty
        {
            Windows::UI::Xaml::DependencyProperty^ get()
            {
                return textProperty;
            }
        }

        property Platform::String^ Text
        {
            Platform::String^ get()
            {
                return safe_cast<Platform::String^>(GetValue(TextProperty));
            }
            void set(Platform::String^ value)
            {
                SetValue(TextProperty, value);
            }
        }

        // FontFamily property
        static property Windows::UI::Xaml::DependencyProperty^ FontFamilyProperty
        {
            Windows::UI::Xaml::DependencyProperty^ get()
            {
                return fontFamilyProperty;
            }
        }

        property Platform::String^ FontFamily
        {
            Platform::String^ get()
            {
                return safe_cast<Platform::String^>(GetValue(FontFamilyProperty));
            }
            void set(Platform::String^ value)
            {
                SetValue(FontFamilyProperty, value);
            }
         }

        // FontSize property
        static property Windows::UI::Xaml::DependencyProperty^ FontSizeProperty
        {
            Windows::UI::Xaml::DependencyProperty^ get()
            {
                return fontSizeProperty;
            }
        }

        property double FontSize
        {
            double get()
            {
                return static_cast<double>(GetValue(FontSizeProperty));
            }
            void set(double value)
            {
                SetValue(FontSizeProperty, value);
            }
        }

        // FontStyle property
        static property Windows::UI::Xaml::DependencyProperty^ FontStyleProperty
        {
            Windows::UI::Xaml::DependencyProperty^ get()
            {
                return fontStyleProperty;
            }
        }

        property Windows::UI::Text::FontStyle FontStyle
        {
            Windows::UI::Text::FontStyle get()
            {
                return static_cast<Windows::UI::Text::FontStyle>(GetValue(FontStyleProperty));
            }
            void set(Windows::UI::Text::FontStyle value)
            {
                SetValue(FontStyleProperty, value);
            }
        }

        // FontWeight property
        static property Windows::UI::Xaml::DependencyProperty^ FontWeightProperty
        {
            Windows::UI::Xaml::DependencyProperty^ get()
            {
                return fontWeightProperty;
            }
        }

        property Windows::UI::Text::FontWeight FontWeight
        {
            Windows::UI::Text::FontWeight get()
            {
                return static_cast<Windows::UI::Text::FontWeight>(GetValue(FontWeightProperty));
            }
            void set(Windows::UI::Text::FontWeight value)
            {
                SetValue(FontWeightProperty, value);
            }
        }

        // Interpolate property
        static property Windows::UI::Xaml::DependencyProperty^ InterpolateProperty
        {
            Windows::UI::Xaml::DependencyProperty^ get()
            {
                return interpolateProperty;
            }
        }

        property bool Interpolate
        {
            void set(bool value)
            {
                SetValue(InterpolateProperty, value);
            }
            bool get()
            {
                return static_cast<bool>(GetValue(InterpolateProperty));
            }
        }

        // Geometry property
        static property Windows::UI::Xaml::DependencyProperty^ GeometryProperty 
        { 
            Windows::UI::Xaml::DependencyProperty^ get()
            {
                return geometryProperty;
            }
        }

        property Windows::UI::Xaml::Media::PathGeometry^ Geometry
        {
            Windows::UI::Xaml::Media::PathGeometry^ get() 
            { 
                return safe_cast<Windows::UI::Xaml::Media::PathGeometry^>(GetValue(GeometryProperty)); 
            }
        }

        // FlattenedGeometry property
        static property Windows::UI::Xaml::DependencyProperty^ FlattenedGeometryProperty
        {
            Windows::UI::Xaml::DependencyProperty^ get()
            {
                return flattenedGeometryProperty;
            }
        }

        property Windows::UI::Xaml::Media::PathGeometry^ FlattenedGeometry
        {
            Windows::UI::Xaml::Media::PathGeometry^ get()
            {
                return safe_cast<Windows::UI::Xaml::Media::PathGeometry^>(GetValue(FlattenedGeometryProperty));
            }
        }
    };
}